=== modified file 'shell.py'
--- shell.py	2005-10-27 14:51:03 +0000
+++ shell.py	2005-10-27 15:17:28 +0000
@@ -167,6 +167,11 @@
         :type endidx: int
         """
         (cmd, args, foo) = self.parseline(line)
+        if cmd == "bzr":
+            try:
+                return self.completenames(text, line, begidx, endidx)
+            except Exception, e:
+                print e
         try:
             command_obj = get_cmd_object(cmd)
         except BzrError:
@@ -252,13 +257,15 @@
         if not hidden and cmd_class.hidden:
             continue
         for name in [real_cmd_name] + cmd_class.aliases:
-            yield name
+            # Don't complete on aliases that are prefixes of the canonical name
+            if name == real_cmd_name or not real_cmd_name.startswith(name):
+                yield name
 
 def iter_munged_completions(iter, arg, text):
     for completion in iter:
         completion = str(completion)
         if completion.startswith(arg):
-            yield completion[len(arg)-len(text):]
+            yield completion[len(arg)-len(text):]+" "
 
 def too_complicated(line):
     for char in '|<>"\"':

